module PLM
  module Model
    class Emath
      class << self
        #
        # Les civilités
        #
        def get_civilities
          [{"civility"=>"_unset_","civilityLabel"=>"Aucune"},
           {"civility"=>"M.","civilityLabel"=>"M."},
           {"civility"=>"Mme","civilityLabel"=>"Mme"}]
        end
      end
      #
      # Les classifications pour cette identité
      #
      def get_classification
        classifications = []
        msc_regexp      = /AMS[0-9]+:(?<code>[0-9]+)/
        persons.map do |emath|
          emath.descriptions.each do |desc|
            if desc=~/^\[AMS[0-9]+:/
              # We reset classification to get only last occurence
              classifications = []
              desc.scan(msc_regexp) { |match| classifications << match.first.to_i }
            end
          end
        end
        classifications
      end
      #
      # Modification de la classification
      #
      def set_classification(req)
        include PLM::Model::JSONHelpers
        schema = JSON.parse File.read(__DIR__+'/../data/msc2010-schema.json')
        if validate_raw_data(schema,req)
          req["classifications"].uniq!
          newmsc=""
          i=0
          req["classifications"].map do |msc|
            newmsc=newmsc+"[AMS#{i}:#{msc}]"
            i += 1
          end
          modEmathProfile({"type"=>"msc2010","value"=>newmsc})
        end
      end

      #
      # La civilité de cette identité
      #
      def get_civility
        title = "_unset_"

        persons.map do |emath|
          title = if emath.title =~ /^(M\.|Mme)$/i
            emath.title
          end
        end
        title
      end
      #
      # Modification de la civilité
      #
      def set_civility(req)
        if req && req["civility"] && req["civility"] =~ /^(M\.|Mme|_unset_)$/i
          modEmathProfile({"type"=>"title","value"=>req["civility"]})
        end
      end
    end
  end
end
