module PLM
  module Model
    class Plm
      #
      # Shells disponibles
      #
      SHELLS = [
        {"loginShell"=>"/bin/false"},
        {"loginShell"=>"/bin/bash"},
        {"loginShell"=>"/bin/csh"},
        {"loginShell"=>"/bin/zsh"}
      ]

      class << self
        def get_shells
          SHELLS
        end

        def associate(uid,mail)
          if (user = find(uid))
            user.add_or_create_mailAlternateAddress(mail)
          end
          false
        end
      end

      def to_hash(me=false)
        {
          familyName: sn,
          givenName: cn,
          login: uid,
          contactEmail: mail,
          plmEmail: mailMathrice || '',
          otherEmails: mailAlternateAddresses,
          shell: loginShell,
          expired: expired?,
          affectation: affectation,
          affectations: affectations,
          id: uidNumber,
          workflowTokens: me ? workflowTokens : [],
          primaryAffectation: primaryAffectation,
          secondaryAffectations: secondaryAffectations
        }
      end

      def get_shells
        SHELLS
      end

      def get_shell
        s={}
        s[:loginShell] = loginShell
      end

      #
      # Modifie le loginShell du compte
      #
      def update_shell(req)
        if req && req[:loginShell] &&
          get_shells.select{|shell| shell["loginShell"] == req[:loginShell]}
          set_shell(req[:loginShell])
        end
        return false
      end

      def get_mails(mail_profile)
        h=[]
        if mail != mail_profile
          h.push({removable:false,type:'plm',email:mail})
          mailAlternateAddresses.each do |m|
            unless m.downcase == mail_profile
              h.push({removable:true,type:'alt',email:m})
            end
            h.uniq!{ |s| s[:email] }
          end
        end
        h
      end

      def del_mail(req, mail_profile)
        unless req["mail"].nil?
          mails = mailAlternateAddresses
          mails.map! do |m|
            m.downcase!
            mail unless req["mail"].downcase == mail && mail != mail_profile
          end
          update_mailAlternateAddress(mails.compact)
        end
      end

      #
      # Obtenir les informations sur la branche PLM (descrition du labo et correspondants)
      # On y ajoute aussi les infos des labos emath correspondants
      #
      def get_labs
        a=[]
        branches.each { |b| a.push(b.to_hash) }
        a
      end

    end
  end
end
